libcamera v0.5.1 Supporting cameras in Linux since 2019 |

Loading...
Searching...
No Matches
Enumerations | Variables
libcamera::controls::rpi Namespace Reference

Namespace for rpi controls. More...

## Enumerations
enum | { STATS_OUTPUT_ENABLE = 20001 , BCM2835_STATS_OUTPUT = 20002 , SCALER_CROPS = 20003 , PISP_STATS_OUTPUT = 20004 }

## Variables
const Control< bool > | StatsOutputEnable
| Toggles the Raspberry Pi IPA to output the hardware generated statistics.
const Control< Span< const uint8_t > > | Bcm2835StatsOutput
| Span of the BCM2835 ISP generated statistics for the current frame.
const Control< Span< const Rectangle > > | ScalerCrops
| An array of rectangles, where each singular value has identical functionality to the ScalerCrop control. This control allows the Raspberry Pi pipeline handler to control individual scaler crops per output stream.
const Control< Span< const uint8_t > > | PispStatsOutput
| Span of the PiSP Frontend ISP generated statistics for the current frame. This is sent in the Request metadata if the StatsOutputEnable is set to true. The statistics struct definition can be found in https://github.com/raspberrypi/libpisp/blob/main/src/libpisp/frontend/pisp_statistics.h.

## Detailed Description

Namespace for rpi controls.

## Variable Documentation

## ◆ Bcm2835StatsOutput

const Control<Span<const uint8_t> > libcamera::controls::rpi::Bcm2835StatsOutput
| extern

Span of the BCM2835 ISP generated statistics for the current frame.

This is sent in the Request metadata if the StatsOutputEnable is set to true. The statistics struct definition can be found in include/linux/bcm2835-isp.h.

See also
  StatsOutputEnable

## ◆ PispStatsOutput

const Control<Span<const uint8_t> > libcamera::controls::rpi::PispStatsOutput
| extern

Span of the PiSP Frontend ISP generated statistics for the current frame. This is sent in the Request metadata if the StatsOutputEnable is set to true. The statistics struct definition can be found in https://github.com/raspberrypi/libpisp/blob/main/src/libpisp/frontend/pisp_statistics.h.

See also
  StatsOutputEnable

## ◆ ScalerCrops

const Control<Span<const Rectangle> > libcamera::controls::rpi::ScalerCrops
| extern

An array of rectangles, where each singular value has identical functionality to the ScalerCrop control. This control allows the Raspberry Pi pipeline handler to control individual scaler crops per output stream.

The order of rectangles passed into the control must match the order of streams configured by the application. The pipeline handler will only configure crop retangles up-to the number of output streams configured. All subsequent rectangles passed into this control are ignored by the pipeline handler.

If both rpi::ScalerCrops and ScalerCrop controls are present in a ControlList, the latter is discarded, and crops are obtained from this control.

Note that using different crop rectangles for each output stream with this control is only applicable on the Pi5/PiSP platform. This control should also be considered temporary/draft and will be replaced with official libcamera API support for per-stream controls in the future.

See also
  ScalerCrop

## ◆ StatsOutputEnable

const Control<bool> libcamera::controls::rpi::StatsOutputEnable
| extern

Toggles the Raspberry Pi IPA to output the hardware generated statistics.

When this control is set to true, the IPA outputs a binary dump of the hardware generated statistics through the Request metadata in the Bcm2835StatsOutput control.

See also
  Bcm2835StatsOutput